/********************************************************************
 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *******************************************************************/

/** INCLUDES *******************************************************/
#include <system.h>
#include <system_config.h>

#include <usb/usb.h>
#include <usb/usb_device_hid.h>

#include <app_device_custom_hid.h>
#include <app_led_usb_status.h>

#define Control_W 0b10111010 //ＬＰＳ３３１書込み制御コード
#define Control_R 0b10111011 //ＬＰＳ３３１読込制御コード

#define trig   PORTDbits.RD0
#define echo PORTDbits.RD1


uint16_t HC_SR();
uint16_t  PutEarth();
void PutTGS2450();

void PutAM2321_N();
void PutAM2321();
void MygetsI2C(  unsigned char length );

unsigned char rdptr[20];
unsigned char data[512];
long AD1,AD2,AD3,AD4,AD5,AD6;

MAIN_RETURN main(void)
{
    uint16_t DataNoMax=2000;
    int i,j,N;
    int FLG=0,FLG2=0;
    uint16_t X;
    long LC=0;

    //N=10;
    SYSTEM_Initialize(SYSTEM_STATE_USB_START);
    TRISD   =	0b00000000;
    PORTD = 0x00;

    TRISE   =   0b00000011;         //SW1,2=INPUT LED=OUTPUT
    PORTEbits.RE2=0;//LED OFF
    PEIE = 0;// 周辺機能割込みの許可
    GIE = 0;// 全体の割込み許可

    while(PORTEbits.RE0==1 && PORTEbits.RE1==1){}

    if(PORTEbits.RE1==1)
    {
        DataNo=0;
        while(FLG == 0)
        {
            PORTEbits.RE2=1;//LED ON


            X=PutEarth();


            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+8,SendData[1]);}
            __delay_ms( 5 ); //5mS
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+9,SendData[2]);}
            __delay_ms( 5 ); //5mS
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+10,SendData[3]);}
            __delay_ms( 5 ); //5mS
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+11,SendData[4]);}
            __delay_ms( 5 ); //5mS

            PutTGS2450();
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+12,SendData[5]);}
            __delay_ms( 5 ); //5mS
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+13,SendData[6]);}
            __delay_ms( 5 ); //5mS


            PutAM2321_N();
            
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+14,SendData[7]);}
            __delay_ms( 5 ); //5mS
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+15,SendData[8]);}
            __delay_ms( 5 ); //5mS
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+16,SendData[9]);}
            __delay_ms( 5 ); //5mS
            if(DataNo < DataNoMax){Write_EPROM(10*DataNo+17,SendData[10]);}
            __delay_ms( 5 ); //5mS




            DataNo=DataNo+1;
            FLG2=1;
            if(FLG == 1){break;}


            PORTEbits.RE2=0;//LED OFF
            for(j=0;j<585;j++)
            {
                for(i=0;i<100;i++)
                {
                    __delay_ms( 10 );
                    if(PORTEbits.RE1==0){FLG=1;}
                }
                if(FLG == 1){break;}
            }

            for(i=0;i<41;i++)
            {
                __delay_ms( 10 );
                if(PORTEbits.RE1==0){FLG=1;}
            }
            __delay_ms( 7 );
            
        }
        PORTEbits.RE2=0;//LED OFF

        if(FLG2 == 1)
        {
        unsigned char    DataNo_H, DataNo_L;
        DataNo_L=DataNoMax;
        DataNo_H=DataNoMax >> 8;
        Write_EPROM(4,DataNo_H);
        __delay_ms( 5 ); //5mS
        Write_EPROM(5,DataNo_L);
        __delay_ms( 5 ); //5mS

        DataNo_L=DataNo;
        DataNo_H=DataNo >> 8;
        Write_EPROM(6,DataNo_H);
        __delay_ms( 5 ); //5mS
        Write_EPROM(7,DataNo_L);
        __delay_ms( 5 ); //5mS
        }

        

    }


    for(i=0;i<10;i++)
    {
        PORTEbits.RE2=~PORTEbits.RE2;
        for(j=0;j<50;j++){__delay_ms( 10 );}
    }

    PEIE = 1;// 周辺機能割込みの許可
    GIE = 1;// 全体の割込み許可

    USBDeviceInit();
    USBDeviceAttach();
    while(1)
    {
        //PORTEbits.RE2=0;//LED OFF
        SYSTEM_Tasks();
        #if defined(USB_POLLING)
            // Interrupt or polling method.  If using polling, must call
            // this function periodically.  This function will take care
            // of processing and responding to SETUP transactions
            // (such as during the enumeration process when you first
            // plug in).  USB hosts require that USB devices should accept
            // and process SETUP packets in a timely fashion.  Therefore,
            // when using polling, this function should be called
            // regularly (such as once every 1.8ms or faster** [see
            // inline code comments in usb_device.c for explanation when
            // "or faster" applies])  In most cases, the USBDeviceTasks()
            // function does not take very long to execute (ex: <100
            // instruction cycles) before it returns.
            USBDeviceTasks();
        #endif

        /* If the USB device isn't configured yet, we can't really do anything
         * else since we don't have a host to talk to.  So jump back to the
         * top of the while loop. */
        if( USBGetDeviceState() < CONFIGURED_STATE )
        {
            /* Jump back to the top of the while loop. */
            continue;
        }

        /* If we are currently suspended, then we need to see if we need to
         * issue a remote wakeup.  In either case, we shouldn't process any
         * keyboard commands since we aren't currently communicating to the host
         * thus just continue back to the start of the while loop. */
        if( USBIsDeviceSuspended() == true )
        {
            /* Jump back to the top of the while loop. */
            continue;
        }

        //Application specific tasks
        APP_DeviceCustomHIDTasks();

        LC=LC+1;
        if(LC > 20000)
        {
            PORTEbits.RE2=~PORTEbits.RE2;
            LC=0;
        }

    }//end while
}//end main


bool USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, uint16_t size)
{
    switch((int)event)
    {
        case EVENT_TRANSFER:
            break;

        case EVENT_SOF:
            /* We are using the SOF as a timer to time the LED indicator.  Call
             * the LED update function here. */
            APP_LEDUpdateUSBStatus();
            break;

        case EVENT_SUSPEND:
            /* Update the LED status for the suspend event. */
            APP_LEDUpdateUSBStatus();
            break;

        case EVENT_RESUME:
            /* Update the LED status for the resume event. */
            APP_LEDUpdateUSBStatus();
            break;

        case EVENT_CONFIGURED:
            /* When the device is configured, we can (re)initialize the demo
             * code. */
            APP_DeviceCustomHIDInitialize();
            break;

        case EVENT_SET_DESCRIPTOR:
            break;

        case EVENT_EP0_REQUEST:
            /* We have received a non-standard USB request.  The HID driver
             * needs to check to see if the request was for it. */
            USBCheckHIDRequest();
            break;

        case EVENT_BUS_ERROR:
            break;

        case EVENT_TRANSFER_TERMINATED:
            break;

        default:
            break;
    }
    return true;
}



/*void Write_EPROM(uint16_t addr,unsigned char send_data)
{
    data[addr]=send_data;
}

unsigned char   Read_EPROM(uint16_t addr)
{

    return data[addr];
}*/

void Write_EPROM(uint16_t addr,unsigned char send_data)
{
    TRISB   =	0b00000011; //B1=SCL(INPUT),BO=SDA(OUTPUT)I2C通信
    SSPCON1 = 0x28;		// SSP enable & I2C Master mode, clock = FOSC / (4 * (SSPADD+1))
    SSPADD = 0x0F;		// 0x00だと動作しないクロック設定

    unsigned char    addr1, addr2;
    addr2=addr;
    addr1=addr >> 8;

     //１バイト書込み
        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.SEN = 1;//I2C_startビット
	while (SSPCON2bits.SEN) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};
	SSPBUF =0xA0;//0xA0 //書込み制御コード
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11111110;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};//SSPBUFの干渉確認
	SSPBUF = addr1; // 書き込みアドレス1
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11111101;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};//SSPBUFの干渉確認
	SSPBUF = addr2;// 書き込みアドレス2
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11111100;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};//SSPBUFの干渉確認
	SSPBUF =send_data;// send_data書き込み
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11111011;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.PEN = 1;//I2C_通信終了
	while (SSPCON2bits.PEN) {}//終了待ち

}

unsigned char   Read_EPROM(uint16_t addr)
{
    TRISB   =	0b00000011; //B1=SCL(INPUT),BO=SDA(OUTPUT)I2C通信
    SSPCON1 = 0x28;		// SSP enable & I2C Master mode, clock = FOSC / (4 * (SSPADD+1))
    SSPADD = 0x0F;		// 0x00だと動作しないクロック設定

    unsigned char    addr1, addr2;
    unsigned char data=5;


    addr2=addr;
    addr1=addr >> 8;

    //１バイト読込
        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.SEN = 1;//I2C_startビット
	while (SSPCON2bits.SEN) {}

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};//SSPBUFの干渉確認
	SSPBUF =0xA0;//0xA0//書込み制御コード
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11111010;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};//SSPBUFの干渉確認
	SSPBUF = addr1;// 書き込みアドレス1
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11111001;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};//SSPBUFの干渉確認
	SSPBUF = addr2; // 書き込みアドレス2
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11111000;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	SSPCON2bits.SEN = 1;//I2C_startビット
	while (SSPCON2bits.SEN) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        while(SSPSTATbits.BF){};//SSPBUFの干渉確認
	SSPBUF =  0xA1; //0xA1 //読込制御コード
        if (SSPCON2bits.ACKSTAT) {PORTD=0b11110111;}//ACKチェック
	while (!PIR1bits.SSPIF) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.RCEN = 1;//受信モードを動作
	while (SSPCON2bits.RCEN) {}//終了待ち

	data=SSPBUF;//受信コピー

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        SSPCON2bits.ACKDT = 1;//受信の終わりで応答シーケンスを開始1=NO-ACK
        SSPCON2bits.ACKEN = 1;//、ACKDT データビットを送信する。
	while (SSPCON2bits.ACKEN) {}//終了待ち

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.PEN = 1;//I2C_通信終了
	while (SSPCON2bits.PEN) {}//終了待ち

    return data;
}




uint16_t HC_SR()
{
    uint16_t range;
    TRISD=0xfe;
    PORTD=0xfe;
    
        TMR1H=0xff;
        TMR1L=-24;
        T1CON=0x31;
        TMR1IF=0;
        trig=1;
        while(!TMR1IF);
        trig=0;
        TMR1ON=0;
        TMR1H=0;
        TMR1L=0;
        T1CON=0x30;
        TMR1IF=0;
        while(!echo && !TMR1IF);
        TMR1ON=1;
        while(echo && !TMR1IF);
        TMR1ON=0;
        range=(TMR1H << 8) + TMR1L;

        SendData[0]=0x02;
        SendData[1]=TMR1H;//上位読込
        SendData[2]=TMR1L;//下位読込
        //mm=range/8.86;
    return range;
}

uint16_t  PutEarth()
{
    // 割込み全体の禁止
	GIE = 0;

    ADCON0	=	0b00000001; //A/D converter module is enabled:A/D Idle:Channel 0 (AN0)
    ADCON1  =	0b00001110; //AN0のみアナログ設定：VDDとVSSが選択
    TRISAbits.TRISA0 = 1; //RA0（AN0)を入力設定
    ADCON0bits.CHS = 0b0000; //Analog Channel Select bits=Channel 0 (AN0)

    //__delay_ms( 5 ); //5mS
    uint16_t    result;
    long N=160,X1=0,X2=0;
    int i;



    //__delay_ms( 10 );
    PORTDbits.RD0 = 1;
    PORTDbits.RD1 = 0;
    __delay_ms( 2 );
    for(i=0;i<N;i++)
    {
        ADCON0bits.GO = 1;              // Start AD conversion
        while(ADCON0bits.NOT_DONE);     // Wait for conversion
        result = ADRESH;
        result <<=  8;
        result |= ADRESL;
        X1 = X1 + result;
        __delay_ms( 1 );
    }
    PORTDbits.RD0 = 0;
    PORTDbits.RD1 = 0;

    X1=X1/10;
    SendData[0]=0x01;//エコー
    SendData[1]=X1/256;
    SendData[2]=X1;


    PORTDbits.RD0 = 0;
    PORTDbits.RD1 = 1;
    __delay_ms( 2 );
    for(i=0;i<N;i++)
    {
        ADCON0bits.GO = 1;              // Start AD conversion
        while(ADCON0bits.NOT_DONE);     // Wait for conversion
        result = ADRESH;
        result <<=  8;
        result |= ADRESL;
        X2 = X2 + result;
        __delay_ms( 1 );
    }
    PORTDbits.RD0 = 0;
    PORTDbits.RD1 = 0;

    X2=X2/10;
    SendData[3]=X2/256;
    SendData[4]=X2;



    // 割込み全体の許可
	GIE = 1;

        return result;
}

void PutTGS2450()
{
    uint16_t    result;
    long N=16,X1=0;
    int i,j;

    // 割込み全体の禁止
    GIE = 0;

    ADCON0	=	0b00000101; //A/D converter module is enabled:A/D Idle:Channel 0 (AN0)
    ADCON1  =	0b00001101; //AN0のみアナログ設定：VDDとVSSが選択
    TRISAbits.TRISA1 = 1; //RA0（AN0)を入力設定
    ADCON0bits.CHS = 0b0001; //Analog Channel Select bits=Channel 0 (AN0)

    //__delay_ms( 5 ); //5mS
    for(i=0;i<N;i++)
    {
         PORTDbits.RD2 = 1;
         __delay_ms( 3 );
         PORTDbits.RD3 = 1;
         __delay_ms( 5 );
         ADCON0bits.GO = 1;              // Start AD conversion
         while(ADCON0bits.NOT_DONE);     // Wait for conversion
         PORTDbits.RD2 = 0;
         PORTDbits.RD3 = 0;

         result = ADRESH;
         result <<=  8;
         result |= ADRESL;
         X1 = X1 + result;


         for (  j = 0; j < 242; j++ ){ __delay_ms( 1 );}

    }
    SendData[5]=X1/256;
    SendData[6]=X1;

    // 割込み全体の許可
    GIE = 1;
   
}

void PutAM2321_N()
{
    // 割込み全体の禁止
	GIE = 0;

    int i,ii;
    long AD1,AD2;

    AD1=0;AD2=0;
    for(i=0;i<10;i++)
    {
        PutAM2321();
        AD1=AD1+((long)SendData[7]*256) + (long)SendData[8];	//湿度1
        AD2=AD2+((long)SendData[9]*256) + (long)SendData[10];	//気温2
        ii=0;
        for(ii=0;ii<100;ii++){__delay_ms( 10 );}
    }
    SendData[7]=AD1/256;

    SendData[8]=AD1;

    SendData[9]=AD2/256;

    SendData[10]=AD2;

    ii=0;
    

    // 割込み全体の許可
    GIE = 1;
    

}

void PutAM2321()
{
    TRISB   =	0b00000011; //B1=SCL(INPUT),BO=SDA(OUTPUT)I2C通信
    SSPCON1 = 0x28;		// SSP enable & I2C Master mode, clock = FOSC / (4 * (SSPADD+1))
    SSPADD = 0x4A;		// 0x00だと動作しないクロック設定




        //１バイト読込

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.SEN = 1;//I2C_startビット
	while (SSPCON2bits.SEN) {}

	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        SSPBUF = 0xB8; // AM2321書込み制御コード
	while (!PIR1bits.SSPIF) {}//終了待ち
        //__delay_ms( 1 ); //1mS*/
        int ii;
        for(ii=0;ii<1;ii++){__delay_ms( 1 ); }

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.PEN = 1;//I2C_通信終了
	while (SSPCON2bits.PEN) {}//終了待ち


        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.SEN = 1;//I2C_startビット
	while (SSPCON2bits.SEN) {}

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPBUF = 0xB8; // AM2321書込み制御コード
	while (!PIR1bits.SSPIF) {}//終了待ち

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPBUF = 0x03; // 書き込みアドレス2
	while (!PIR1bits.SSPIF) {}//終了待ち

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPBUF = 0x00; // 書き込みアドレス2
	while (!PIR1bits.SSPIF) {}//終了待ち

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPBUF = 0x04; // 書き込みアドレス2
	while (!PIR1bits.SSPIF) {}//終了待ち

        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.PEN = 1;//I2C_通信終了
	while (SSPCON2bits.PEN) {}//終了待ち

        //__delay_ms( 2 ); //1mS*/
        for(ii=0;ii<2;ii++){__delay_ms( 1 ); }


        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.SEN = 1;//I2C_startビット
	while (SSPCON2bits.SEN) {}


        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPBUF = 0xB9; // AM2321読込制御コード
	while (!PIR1bits.SSPIF) {}//終了待ち

        //__delay_us(30 ); //1mS*/
        for(ii=0;ii<30;ii++){__delay_ms( 1 );}


        signed char Ref;
        //Ref=getsI2C(rdptr,8 );
        MygetsI2C(8 );


        PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
        SSPCON2bits.ACKDT = 1;//受信の終わりで応答シーケンスを開始1=NO-ACK
        SSPCON2bits.ACKEN = 1;//、ACKDT データビットを送信する。
	while (SSPCON2bits.ACKEN) {}//終了待ち


	PIR1bits.SSPIF = 0;//I2C_通信割込みフラグクリア
	SSPCON2bits.PEN = 1;//I2C_通信終了
	while (SSPCON2bits.PEN) {}//終了待ち
}

void MygetsI2C( unsigned char length )
{
    int i=0;
    while ( length-- )           // perform getcI2C() for 'length' number of bytes
    {
	SSPCON2bits.RCEN = 1;           // enable master for 1 byte reception
        while ( !SSPSTATbits.BF );      // wait until byte received
        rdptr[i] = SSPBUF;       // save byte received
        while ( SSPCON2bits.RCEN ); // check that receive sequence is over
        if ( length )               // test if 'length' bytes have been read
        {
            SSPCON2bits.ACKDT = 0;    // set acknowledge bit state for ACK
            SSPCON2bits.ACKEN = 1;    // initiate bus acknowledge sequence
            while ( SSPCON2bits.ACKEN ); // wait until ACK sequence is over
      }
        i++;
    }

    SendData[7]=rdptr[2];
    SendData[8]=rdptr[3];
    SendData[9]=rdptr[4];
    SendData[10]=rdptr[5];
}




/*******************************************************************************
 End of File
*/

